function readfromfile(name: string): string;
  begin
    result := readfile(name);
    result := copy(result, 0, length(result) - 2);
  end;

function xfileexists(name: string): boolean;
  begin
    result := false;
    if getsystem() = 'windows' then begin
      if fileexists(name) then result := true;
    end else
      if (fileexists(name)) or (readfromfile(name) <> '') then result := true;
  end;

function xsplit(const source: string; const delimiter: string): tstringarray;
  var i, x, d: integer;
      s: string;
  begin
    d := length(delimiter);
    x := 0;
    i := 1;
    setarraylength(result, 1);
    while i <= length(source) do begin
      s := copy(source, i, d);
      if s = delimiter then begin
        inc(i, d);
        inc(x, 1);
        setarraylength(result, x + 1);
      end else begin
        result[x] := result[x] + copy(s, 1, 1);
        inc(i, 1);
      end;
    end;
  end;

procedure setscriptstate(directory: string; state: boolean);
  var newfile, newfiletmp: string;
  begin
    directory := iif(copy(directory, length(directory) - 1, length(directory)) = '/', directory, directory + '/');
    newfile := readfile(directory + 'Includes.txt');
    while newfiletmp <> newfile do begin
      newfiletmp := newfile;
      newfile := RegExpReplace(iif(state, '\/\/([^\r\n]+)([\r\n])', '(^|[\r\n])([^\r\n/]+)([\r\n]|$)'), newfile, iif(state, '$1$2', '$1//$2$3'), true);
    end;
    writefile(directory + 'Includes.txt', newfile);
	end;