function readfromfile(name: string): string;
  begin
    result := readfile(name);
    result := copy(result, 0, length(result) - 2);
  end;



function xfileexists(name: string): boolean;
  begin
    result := false;
    if getsystem() = 'windows' then begin
      if fileexists(name) then result := true;
    end else
      if (fileexists(name)) or (readfromfile(name) <> '') then result := true;
  end;



function xsplit(const source: string; const delimiter: string): tstringarray;
  var i, x, d: integer;
      s: string;
  begin
    d := length(delimiter);
    x := 0;
    i := 1;
    setarraylength(result, 1);
    while i <= length(source) do begin
      s := copy(source, i, d);
      if s = delimiter then begin
        inc(i, d);
        inc(x, 1);
        setarraylength(result, x + 1);
      end else begin
        result[x] := result[x] + copy(s, 1, 1);
        inc(i, 1);
      end;
    end;
  end;



function trimini(str: tstringarray): tstringarray;
  var
    i, j, strlen: integer;
    res: tstringarray;
  begin
    strlen := arrayhigh(str);
    if strlen = 0 then begin
      setarraylength(res, 1);
      res[0] := str[0]
    end else begin
      j := 0;
      setarraylength(res, strlen + 1);
      for i := 0 to strlen do res[i] := ''; 
      for i := 0 to strlen - 1 do begin
        if length(str[i + 1]) >= 1 then begin 
          if str[i + 1][1] = '[' then begin 
            if str[i] <> ''  then begin 
              res[j] := str[i];       
              j := j + 1;               
            end;
            res[j] := '';  
            j := j + 1;        
            continue;      
          end;
        end;
        if str[i] = '' then continue;    
        res[j] := str[i];               
        j := j + 1;                   
      end;
    end;
    result := res;
  end;



function trimnewlines(entirefile: tstringarray): tstringarray;
  var
    rest: tstringarray;
    i, filelength: integer;
  begin
    filelength := arrayhigh(entirefile);
    setarraylength(rest, filelength + 1);
    for i := 0 to filelength do begin
      if entirefile[i] = '' then if i <> 0 then if entirefile[i - 1] = '' then begin
        rest[i] := '-';
        continue;
      end;
      rest[i] := entirefile[i];
    end;
    result:=rest;
  end;



procedure writeini(filename, section, key, data: string);
  var
    entirefile, entirefile2: tstringarray;
    i, j, filelength: integer;
    replace: boolean;
  begin
    { make sure the ini exists, otherwise touch it }
    if not xfileexists(filename) then writefile(filename, '');

    { search for the given [section] and store the position in i }
    setarraylength(entirefile, 1);
    entirefile := xsplit(readfile(filename), chr(13) + chr(10));
    i := 0;
    filelength := arrayhigh(entirefile);
    while uppercase(entirefile[i]) <> ('[' + uppercase(section) + ']') do begin
      i := i + 1;
      if i > filelength then break;
    end;

    { if the section doesnt exist we need to create it first }
    if i > filelength then begin
      i := getarraylength(entirefile);
      setarraylength(entirefile, i + 4);
      entirefile[i + 1] := '';
      entirefile[i + 2] := '[' + section + ']';
      i := i + 2;
    end;

    { search for matches for the key under the given section }
    j := 0;
    replace := true;
    while replace do begin
      j := j + 1;
      if i + j > filelength then begin
        replace := false;
        break;
      end;
      if maskcheck(entirefile[i + j], '[*]') then replace := false;
      if maskcheck(entirefile[i + j], key + '*') then break; { replace = true, i+j is the index of the element to replace }
    end;

    { if the key exist we want to replace it, otherwise create a new one. }
    if not replace then begin
      { create the new key }
      i := i + 1;
      setarraylength(entirefile, getarraylength(entirefile) + 1);
      filelength := arrayhigh(entirefile);
      for j := 1 to filelength - i do
    entirefile[filelength - j + 1] := entirefile[filelength - j];
      entirefile[i] := key + '=' + data;
    end else
      { replace the already existing key }
      entirefile[i + j] := key + '=' + data;

    { remove all annoying whitespace }
    entirefile2 := trimnewlines(entirefile);

    writefile(filename, ''); { make sure the file is empty }
    for i := 0 to arrayhigh(entirefile2) do begin
     if entirefile2[i] = '-' then continue;
      writelnfile(filename, entirefile2[i]);
    end;
  end;